]> git.pld-linux.org Git - projects/rc-scripts.git/blame - rc.d/init.d/functions
- calculate default INIT_COL from terminal size
[projects/rc-scripts.git] / rc.d / init.d / functions
CommitLineData
356d834b 1#!/bin/sh - keep it for file(1) to get bourne shell script result
7742e157
AF
2# functions This file contains functions to be used by most or all
3# shell scripts in the /etc/init.d directory.
4#
ec8b15cb 5# $Id$
7742e157
AF
6#
7# Author: Miquel van Smoorenburg, <miquels@drinkel.nl.mugnet.org>
8a835e11 8# Hacked by: Greg Galloway and Marc Ewing
ffe19b59 9# Modified for PLD Linux by:
ec8b15cb 10# Marek Obuchowicz <elephant@pld-linux.org>
fdc764ae
ER
11# Arkadiusz Miśkiewicz <misiek@pld-linux.org>
12# Michał Kochanowicz <mkochano@pld-linux.org>
13# Łukasz Pawelczyk <havner@pld-linux.org>
7742e157
AF
14
15# First set up a default search path.
cee18a41 16export PATH="/sbin:/usr/sbin:/bin:/usr/bin:/usr/X11R6/bin"
7742e157 17
d7e5835b 18# Set defaults
66f7cfac
ER
19if [ -z "$COLUMNS" -o -z "$LINES" ]; then
20 _setterm() {
21 set -- $(stty size 2>/dev/null)
22 LINES=${LINES:-$1}
23 COLUMNS=${COLUMNS:-$2}
24 }
25 _setterm
26 unset _setterm
27fi
28[ -z "$COLUMNS" ] && COLUMNS=80
29export LINES COLUMNS
30INIT_COL=$((COLUMNS - 13))
9e9fac7d 31
503bfc80
AM
32# Set colors
33RED=1
34GREEN=2
35YELLOW=3
36BLUE=4
37MAGENTA=5
38CYAN=6
39WHITE=7
40NORMAL=9
41# Bold definition (second parameter to termput setaf)
42BOLD=1
43NOBOLD=0
44# Default colors
45CBRACKETS="$CYAN" # brackets [ ] color
46CDONE="$GREEN" # DONE and WORK color
47CBUSY="$MAGENTA" # BUSY color
48CFAIL="$RED" # FAIL and DIED color
49CPOWEREDBY="$CYAN" # "Powered by" color
50CPLD="$GREEN" # "PLD Linux Distribution" color
51CI="$RED" # Capital I color (press I to enter interactive startup)
52CRESMAN="$GREEN" # "Resource Manager" color
bca43764 53CHARS="" # Characters displayed on the beginning of show line
503bfc80
AM
54CCHARS="$NORMAL" # Color of these characters (look at /etc/sysconfig/init-colors.gentoo example)
55
d7e5835b 56# Source configuration if available - may override default values
503bfc80 57[ -r /etc/sysconfig/init-colors ] && . /etc/sysconfig/init-colors
de1fc6ce 58[ -r /etc/sysconfig/system ] && . /etc/sysconfig/system
7f229d88 59[ -r /etc/sysconfig/bootsplash ] && . /etc/sysconfig/bootsplash
7e04fe0e 60
9e22837c 61if [ -z "$VSERVER" -o "$VSERVER" = "detect" ]; then
ce397bd8
JR
62 {
63 while read _f _ctx; do
64 [ "$_f" = "VxID:" -o "$_f" = "s_context:" ] && break
65 done </proc/self/status
66 } 2>/dev/null
9e22837c
JR
67 if [ -z "$_ctx" -o "$_ctx" = "0" ]; then
68 VSERVER=no
69 else
70 VSERVER=yes
71 fi
55a4bc1b 72 unset _f _ctx
9e22837c
JR
73fi
74
4132441e
ER
75# we need to know in functions if we were called from a terminal
76if [ -z "$ISATTY" ]; then
77 [ -t ] && ISATTY=yes || ISATTY=no
9cdf2de7 78 export ISATTY
4132441e
ER
79fi
80
18bd13ac 81is_yes() {
13a745bb
AM
82 # Test syntax
83 if [ $# = 0 ] ; then
84 msg_usage " is_yes {value}"
85 return 2
86 fi
87
88 # Check value
89 case "$1" in
739070c4 90 yes|Yes|YES|true|True|TRUE|on|On|ON|Y|y|1)
13a745bb
AM
91 # true returns zero
92 return 0
93 ;;
739070c4 94 *)
13a745bb
AM
95 # false returns one
96 return 1
97 ;;
98 esac
99}
100
18bd13ac 101is_no() {
13a745bb
AM
102 # Test syntax
103 if [ $# = 0 ] ; then
104 msg_usage " is_no {value}"
105 return 2
106 fi
107
108 case "$1" in
739070c4 109 no|No|NO|false|False|FALSE|off|Off|OFF|N|n|0)
13a745bb
AM
110 # true returns zero
111 return 0
112 ;;
739070c4 113 *)
13a745bb
AM
114 # false returns one
115 return 1
116 ;;
117 esac
118}
119
45e0ac73
ER
120# checks if file is empty
121# empty lines and lines beginning with hash are ignored
122is_empty_file() {
123 [ -s "$1" ] || return 0
0011afb6 124 egrep -vq "^(#|[[:blank:]]*$)" "$1" && return 1 || return 0
45e0ac73
ER
125}
126
1626fc86
ER
127# returns OK if $1 contains $2
128strstr() {
4ec13019
ER
129 local a=$2
130 [ "${1#*$a*}" = "$1" ] && return 1
1626fc86
ER
131 return 0
132}
133
bc94aa53 134if is_yes "$FASTRC" || is_yes "$IN_SHUTDOWN"; then
d84e0c78
JR
135 RC_LOGGING=no
136fi
137
bc94aa53 138if is_no "$RC_LOGGING"; then
18bd13ac 139 initlog() {
6d0838f4 140 RESULT=0
bb49a1c7 141 while [ "$1" != "${1##-}" ]; do
0a35929a 142 case $1 in
739070c4 143 -c)
5e6dfc29
JR
144 shift
145 $1
146 RESULT=$?
147 break
148 ;;
739070c4 149 *)
5e6dfc29
JR
150 shift
151 ;;
0a35929a
AM
152 esac
153 done
6d0838f4 154 return $RESULT
0a35929a
AM
155 }
156fi
157
18bd13ac 158kernelver() {
55a4bc1b
JR
159 typeset _x _y _z v old_IFS ver
160 {
161 read _x _y v _z
162 old_IFS=$IFS
163 IFS='.'
164 set -- $v
165 IFS=$old_IFS
28d62f54
ER
166
167 # strip _* or -* from versions like: "2.6.25_vanilla-1", "2.6.25-1"
89ec4154 168 ver=${3%%[-_]*}
28d62f54
ER
169
170 while [ ${#ver} -lt 3 ]; do ver="0$ver"; done
55a4bc1b 171 ver="$2$ver"
28d62f54 172 while [ ${#ver} -lt 6 ]; do ver="0$ver"; done
55a4bc1b 173 ver="$1$ver"
28d62f54 174 while [ ${#ver} -lt 9 ]; do ver="0$ver"; done
55a4bc1b 175 echo $ver
28d62f54 176 } < /proc/version
6f2d09b1
AM
177}
178
18bd13ac 179kernelverser() {
55a4bc1b
JR
180 typeset _x _y _z v old_IFS ver
181 {
182 read _x _y v _z
183 old_IFS=$IFS
184 IFS='.'
185 set -- $v
186 IFS=$old_IFS
187 ver=$2
188 while [ ${#ver} -lt 3 ] ; do ver="0$ver" ; done
189 ver="$1$ver"
190 while [ ${#ver} -lt 6 ] ; do ver="0$ver" ; done
191 echo $ver
192 } </proc/version
6f2d09b1
AM
193}
194
18bd13ac 195kernelvermser() {
55a4bc1b
JR
196 typeset _x _y _z v old_IFS ver
197 {
198 read _x _y v _z
199 old_IFS=$IFS
200 IFS='.'
201 set -- $v
202 IFS=$old_IFS
203 ver="$1$ver"
204 while [ ${#ver} -lt 3 ] ; do ver="0$ver" ; done
205 echo $ver
206 } </proc/version
6f2d09b1
AM
207}
208
cee18a41 209# Colors workaround
18bd13ac 210termput() {
4132441e 211 is_yes "$ISATTY" || return
e3aafb2f 212
294b03eb 213 if is_yes "$FASTRC" || is_no "$TPUT"; then
972964bb 214 case "$1" in
739070c4 215 hpa)
8a835e11 216 echo -ne "\033[$(($2+1))G"
972964bb 217 ;;
739070c4 218 cuu*)
8a835e11 219 echo -ne "\033[${2}A"
972964bb 220 ;;
739070c4 221 el)
8a835e11 222 echo -ne "\033[0K"
972964bb 223 ;;
739070c4 224 setaf)
503bfc80
AM
225 typeset ISBOLD
226 if [ -n "$3" ]; then
227 ISBOLD="$3"
228 else
229 ISBOLD="$NOBOLD";
230 fi
231 is_yes "$COLOR_INIT" && echo -ne "\033[${ISBOLD};3${2}m"
8a835e11 232 ;;
739070c4 233 op)
503bfc80 234 termput setaf $NORMAL
dcb00bd9 235 ;;
8a835e11 236 esac
c6c1bd0c 237 else
8a835e11 238 case "$1" in
739070c4 239 hpa | cuu* | el)
8a835e11 240 tput "$@"
945790a2 241 ;;
739070c4 242 setaf)
503bfc80
AM
243 if [ "$3" == "1" ]; then tput bold; else tput sgr0; fi
244 is_yes "$COLOR_INIT" && tput setaf "$2"
945790a2 245 ;;
739070c4 246 op)
503bfc80 247 termput setaf $NORMAL
945790a2 248 ;;
8a835e11 249 esac
c6c1bd0c
AF
250 fi
251}
cee18a41 252
0c4f3cf5
ER
253if [ ! -x /bin/printf ]; then
254 # printf equivalent
255 # FIXME: buggy when single or double quotes in message!
18bd13ac 256 printf() {
0c4f3cf5
ER
257 typeset text m
258 text="$1"
259 shift
260 if [ $# -gt 0 ]; then
261 m="$1"
262 shift
263 while [ $# -gt 0 ]; do
264 m="$m\",\"$1"
265 shift
266 done
267 fi
268 awk "BEGIN {printf \"$text\", \"$m\"; }"
269 }
270fi
8a835e11 271
38198f50 272# National language support function
18bd13ac 273nls() {
50ed8c3f 274 typeset msg_echo nls_domain text message
d553f606 275 msg_echo='\n'
50ed8c3f 276 nls_domain="$NLS_DOMAIN"
e2c2c3a6 277 while [ "$1" != "${1##-}" ]; do
d553f606 278 case "$1" in
739070c4 279 --nls-domain)
8a835e11 280 shift
50ed8c3f 281 nls_domain="$1"
8a835e11 282 shift
283 ;;
739070c4 284 -n)
8a835e11 285 msg_echo=''
286 shift
287 ;;
d553f606
JR
288 esac
289 done
290 message="$1"
291 shift
50ed8c3f 292
d553f606
JR
293 # empty message, so we return --misiek
294 if [ -z "$message" ]; then
d553f606
JR
295 echo -en "$msg_echo"
296 return
38198f50 297 fi
8a835e11 298
e2c2c3a6
ER
299 if is_yes "$GETTEXT"; then
300 message=$(TEXTDOMAINDIR="/etc/sysconfig/locale" gettext -e --domain="${nls_domain:-rc-scripts}" "$message")
972964bb 301 fi
8a835e11 302
e2c2c3a6 303 printf "$message" "$@"
d553f606 304 echo -en "$msg_echo"
38198f50
AM
305}
306
18bd13ac 307rc_splash() {
fae22957
AM
308 typeset action
309
862c980c
AM
310 action="$1"
311
9e22837c 312 if ! is_no "$BOOT_SPLASH" && ! is_yes "$VSERVER"; then
fae22957
AM
313 [ -x /bin/splash ] && /bin/splash "$action"
314 fi
b6509675
AM
315
316 : $((progress++))
fae22957
AM
317}
318
18bd13ac 319msg_network_down() {
228edf1d 320 nls "ERROR: Networking is down. %s can't be run." "$1" >&2
a916d1c6 321}
322
18bd13ac 323msg_starting() {
a916d1c6 324 show "Starting %s service" "$1"
325}
326
18bd13ac 327msg_already_running() {
599d198a 328 nls "%s service is already running." "$1"
a916d1c6 329}
330
18bd13ac 331msg_stopping() {
a916d1c6 332 show "Stopping %s service" "$1"
333}
334
18bd13ac 335msg_not_running() {
599d198a 336 nls "%s service is not running." "$1"
a916d1c6 337}
338
18bd13ac 339msg_reloading() {
a916d1c6 340 show "Reloading %s service" "$1"
341}
342
18bd13ac 343msg_usage() {
599d198a 344 nls "Usage: %s" "$*"
a916d1c6 345}
346
ffe19b59 347# Some functions to handle PLD Linux-style messages
18bd13ac 348show() {
ce410bbc
JR
349 typeset text
350 typeset -i len
0a35929a 351
ce410bbc
JR
352 if is_no "$FASTRC" && is_yes "$GETTEXT"; then
353 text=$(nls -n "$@")
354 else
355 text=$(printf "$@")
356 fi
357 len=${#text}
358 while [ $((len++)) -lt $INIT_COL ]; do
359 text="$text."
360 done
361 if [ -n "$CHARS" ]; then
362 termput setaf $CCHARS
363 echo -n "$CHARS"
364 termput op
365 fi
366 echo -n "$text"
7742e157
AF
367}
368
18bd13ac 369deltext() {
a292b175
ER
370 termput hpa $INIT_COL
371}
372
b9cad282 373# Displays message in square brackests ("[ DONE ]"). Takes two arguments.
374# First is the text to display, second is color number to use (argument to
375# tput setaf). If second argument is not given, default (2, green) will be
376# used).
18bd13ac 377progress() {
da1fc19d 378 typeset COLOR
503bfc80 379 if [ -n "$2" ]; then COLOR="$2"; else COLOR="$CDONE"; fi
cd8dfdf0 380 deltext
503bfc80 381 echo -n "$(termput setaf $CBRACKETS)[$(termput setaf $COLOR) $(nls --nls-domain rc-scripts "$1") $(termput setaf $CBRACKETS)]$(termput op)"
b9cad282 382}
383
18bd13ac 384busy() {
a292b175 385 echo -n "$_busy"
7742e157
AF
386}
387
18bd13ac 388ok() {
a292b175 389 echo "$_ok"
7742e157
AF
390}
391
18bd13ac 392started() {
a292b175 393 echo "$_started"
7e04fe0e 394}
395
18bd13ac 396fail() {
a292b175 397 echo "$_fail"
d553f606 398 return 1
7742e157
AF
399}
400
18bd13ac 401died() {
a292b175 402 echo "$_died"
d553f606 403 return 1
6cac3cb2 404}
405
bbb612de 406# Check if $pid (could be plural) are running
18bd13ac 407checkpid() {
8a835e11 408 while [ "$1" ]; do
409 [ -d "/proc/$1" ] && return 0
410 shift
411 done
412 return 1
bbb612de
AM
413}
414
290eb891
AM
415# - outside chroot get only those processes, which are outside chroot.
416# - inside chroot get only those processes, which are inside chroot.
417# - don't filter out pids which do not have corresponding running processes (process died etc)
1e5e8177 418# (note: some processes like named are chrooted but run outside chroot)
c3403882 419# - do nothing inside vserver
18bd13ac 420filter_chroot() {
c3403882
JR
421 if is_yes "$VSERVER"; then
422 echo $@
423 return
424 fi
8e3b6875
AM
425 if [ $# -lt 1 -o ! -d /proc/1 ] ; then
426 echo $@
427 return
428 fi
33ca787f 429 local root_dir good_pids="" good_add_pid
1e5e8177
AM
430 for root_pid in $@; do
431 root_dir=$(resolvesymlink /proc/${root_pid}/root)
432 if [ -n "$root_dir" ]; then
5a8ff397
AM
433 good_add_pid=1
434 if [ -n "${SYSTEM_CHROOTS}" ]; then
435 for r_dir in ${SYSTEM_CHROOTS}; do
436 echo "$root_dir" | grep -q "^${r_dir}" && good_add_pid=0
437 done
438 fi
439 [ "$good_add_pid" -eq 1 ] && good_pids="$good_pids $root_pid"
290eb891
AM
440 elif [ ! -d "/proc/$root_pid" ]; then
441 good_pids="$good_pids $root_pid"
1e5e8177 442 fi
5a8ff397
AM
443 done
444 echo $good_pids
1e5e8177
AM
445}
446
cee18a41 447# Usage run_cmd Message command_to_run
18bd13ac 448run_cmd() {
da1fc19d 449 typeset exit_code errors message force_err
d553f606
JR
450 typeset -i force_err=0
451 typeset -i exit_code=0
452 case "$1" in
739070c4 453 -a)
8a835e11 454 force_err=1
455 shift
456 ;;
d553f606
JR
457 esac
458 message=$1
459 show "$message"; busy
1b228409 460 shift
90c59319 461 cd /
f10f2102
ER
462 if errors=$(
463 export HOME=/tmp TMPDIR=/tmp
464 if is_no "$RC_LOGGING"; then
465 "$@" 2>&1
466 else
467 initlog -c "$*" 2>&1
468 fi
469 ); then
cd8dfdf0 470 ok
d553f606 471 log_success "$1 $message"
1b228409 472 else
d553f606
JR
473 fail
474 log_failed "$1 $message"
b7299ffc 475 exit_code=1
1b228409 476 fi
d553f606 477 [ -n "$errors" ] && [ $exit_code -eq 1 -o $force_err -eq 1 ] && echo "$errors"
1b228409 478 return $exit_code
cee18a41
AM
479}
480
e81194ca 481_daemon_set_ulimits() {
0fba6fe4
ER
482 local opt val ksh=${KSH_VERSION:+1}
483 set -- ${SERVICE_LIMITS:-$DEFAULT_SERVICE_LIMITS}
484 while [ $# -gt 0 ]; do
485 opt=$1
486 val=$2
487 if [ "$ksh" ]; then
488 case "$opt" in
489 -Hu)
490 opt=-Hp
491 ;;
492 -Su)
493 opt=-Sp
494 ;;
495 -u)
496 opt=-p
497 ;;
498 esac
499 fi
500 ulimit $opt $val
501 shift 2
502 done
e81194ca
ER
503}
504
e2e24f5a 505# A function to start a program (now it's useful on read-only filesystem too)
18bd13ac 506daemon() {
0a177614 507 typeset errors="" prog="" end="" waitname="" waittime=""
d553f606 508 typeset -i exit_code=0
42595a81 509 local nice=$SERVICE_RUN_NICE_LEVEL
a160c01b 510 local fork user closefds pidfile makepid chdir=/
42595a81
ER
511
512 while [ $# -gt 0 ]; do
d553f606 513 case $1 in
739070c4 514 '')
a160c01b 515 msg_usage " daemon [--check] [--user user] [--fork] [--chdir directory] [--closefds] [--waitforname procname] [--waitfortime seconds] [--pidfile file] [--makepid] [+/-nicelevel] {program} <program args>"
8a835e11 516 return 2
d553f606 517 ;;
739070c4 518 --check)
d553f606
JR
519 # for compatibility with redhat/mandrake
520 nls "warning: --check option is ignored!"
521 shift
d553f606 522 ;;
739070c4 523 --user)
d553f606 524 shift
7b1a2a70 525 [ "$1" != "root" ] && prog="/bin/su $1 -s /bin/sh -c \""
f10f2102 526 user=$1
d553f606 527 ;;
739070c4
ER
528 --fork)
529 fork=1
b486c392
ER
530 prog="/usr/bin/setsid sh -c \""
531 end='&'
b486c392 532 ;;
6b1fd029
ER
533 --chdir)
534 shift
535 chdir=$1
536 ;;
739070c4
ER
537 --closefds)
538 closefds=1
f10f2102 539 ;;
739070c4 540 --waitforname)
b486c392 541 shift
683d384e 542 waitname="$1"
683d384e 543 ;;
739070c4 544 --waitfortime)
b486c392 545 shift
683d384e 546 waittime="$1"
683d384e 547 ;;
739070c4 548 --pidfile)
0a177614
ER
549 shift
550 pidfile="$1"
551 ;;
a160c01b
PG
552 --makepid)
553 makepid=1
554 ;;
739070c4 555 -*|+*)
42595a81 556 nice=$1
a6e727aa 557 shift
42595a81
ER
558 break
559 ;;
739070c4 560 *)
42595a81 561 break
683d384e 562 ;;
d553f606 563 esac
42595a81 564 shift
d553f606 565 done
2eea8492 566 # If command to execute ends with quotation mark, add remaining
567 # arguments and close quotation.
568 if [ "$prog" != "${prog%\"}" ]; then
565736ed 569 prog="$prog $*$end\""
2eea8492 570 else
565736ed 571 prog="$prog $*$end"
2eea8492 572 fi
7742e157 573
e81194ca 574 _daemon_set_ulimits
f054a85e 575
3edf5e48 576 [ -z "$DEFAULT_SERVICE_UMASK" ] && DEFAULT_SERVICE_UMASK=022
42595a81 577 [ -z "$DEFAULT_SERVICE_RUN_NICE_LEVEL" ] && DEFAULT_SERVICE_RUN_NICE_LEVEL=0
3edf5e48 578
7742e157
AF
579 # And start it up.
580 busy
6b1fd029 581 cd $chdir
42595a81 582 [ -n "$SERVICE_CPUSET" ] && is_yes "$CPUSETS" && echo $$ > "/dev/cpuset/${SERVICE_CPUSET}/tasks"
18bd13ac 583 if errors=$(
f10f2102 584 umask ${SERVICE_UMASK:-$DEFAULT_SERVICE_UMASK};
739070c4 585 export USER=root HOME=/tmp TMPDIR=/tmp
f10f2102
ER
586 nice=${nice:-$DEFAULT_SERVICE_RUN_NICE_LEVEL}
587 nice=${nice:-0}
588
589 if [ "$closefds" = 1 ]; then
590 exec 1>&-
591 exec 2>&-
592 exec 0>&-
593 else
594 exec 2>&1
595 fi
596
597 if is_no "$RC_LOGGING" ; then
598 prog=$1; shift
599 if [ ! -x $prog ]; then
600 logger -t rc-scripts -p daemon.debug "daemon: Searching PATH for $prog, consider using full path in initscript"
601 local a o=$IFS
602 IFS=:
603 for a in $PATH; do
604 if [ -x $a/$prog ]; then
605 prog=$a/$prog
606 break
607 fi
608 done
609 IFS=$o
610 fi
611 /sbin/start-stop-daemon -q --start \
612 --nicelevel $nice \
613 ${pidfile:+--pidfile $pidfile} \
a526f709 614 ${user:+-c $user} \
6b1fd029 615 ${chdir:+--chdir "$chdir"} \
f10f2102 616 ${fork:+-b} \
a160c01b 617 ${makepid:+-m} \
f10f2102
ER
618 --exec "$prog" \
619 -- ${1:+"$@"}
620 else
621 nice -n $nice initlog -c "$prog" 2>&1
622 fi
18bd13ac 623 ); then
f10f2102 624
683d384e
AM
625 if [ -n "$waitname" -a -n "$waittime" ]; then
626 # Save basename.
03e01a49 627 base=${waitname##*/}
683d384e
AM
628 # Find pid.
629 pid=$(pidofproc "$waitname" "$pidfile")
630 [ -z "$pid" ] && pid=$(pidofproc "$base" "$pidfile")
631 i=0
632 while [ "$i" -lt "$waittime" ]; do
42595a81 633 i=$((i + 1))
683d384e
AM
634 checkpid $pid && sleep 1 || break
635 done
636 fi
d553f606 637 log_success "$1 startup"
1b228409 638 ok
7742e157 639 else
b7299ffc 640 exit_code=1
1b228409 641 fail
d553f606
JR
642 log_failed "$1 startup"
643 [ -n "$errors" ] && echo "$errors"
7742e157 644 fi
b7299ffc 645 return $exit_code
7742e157
AF
646}
647
648# A function to stop a program.
18bd13ac 649killproc() {
8de7f381 650 typeset notset killlevel base pid pidfile result
7742e157
AF
651 # Test syntax.
652 if [ $# = 0 ]; then
3fa0b8fe 653 msg_usage " killproc [--pidfile PIDFILE] {program} [-SIGNAME]"
228edf1d 654 return 2
7742e157
AF
655 fi
656
bb49a1c7 657 while [ "$1" != "${1##-}" ]; do
8de7f381 658 case $1 in
739070c4 659 --pidfile)
53ae90e8
ER
660 pidfile="$2"
661 shift 2
8de7f381 662 ;;
739070c4 663 --waitforname)
53ae90e8
ER
664 waitname="$2"
665 shift 2
683d384e 666 ;;
739070c4 667 --waitfortime)
53ae90e8
ER
668 waittime="$2"
669 shift 2
683d384e 670 ;;
8de7f381
AM
671 esac
672 done
673
7742e157 674 busy
8a835e11 675
d553f606 676 typeset -i notset=0
7742e157 677 # check for second arg to be kill level
d553f606 678 if [ -n "$2" ] ; then
7742e157
AF
679 killlevel=$2
680 else
681 notset=1
2f269bdf 682 killlevel="-KILL"
7742e157
AF
683 fi
684
2f269bdf
ER
685 # experimental start-stop-daemon based killing.
686 # works only with pidfile
687 if is_no "$RC_LOGGING" && [ "$pidfile" ]; then
5ec58ec2 688 local sig=${killlevel:--TERM}
2f269bdf
ER
689 /sbin/start-stop-daemon --stop \
690 --retry ${sig#-}/10/${sig#-}/60/KILL/10 \
691 -s ${sig#-} \
692 ${pidfile:+--pidfile $pidfile}
693 result=$?
694 if [ "$result" -eq 0 ]; then
695 ok
696 else
697 fail
698 fi
699 return $result
700 fi
701
702
228edf1d 703 # Save basename.
03e01a49 704 base=${1##*/}
7742e157 705
228edf1d 706 # Find pid.
8de7f381
AM
707 pid=$(pidofproc "$1" "$pidfile")
708 [ -z "$pid" ] && pid=$(pidofproc "$base" "$pidfile")
7742e157 709
228edf1d 710 # Kill it.
34b6b730 711 if [ -n "$pid" -a "$pid" != "$$" ] && checkpid $pid 2>&1 ; then
830949ca 712 if [ "$notset" = "1" ] ; then
228edf1d 713 if checkpid $pid 2>&1; then
714 # TERM first, then KILL if not dead
715 kill -TERM $pid
716 usleep 100000
717 if checkpid $pid && sleep 1 &&
718 checkpid $pid && sleep 3 &&
719 checkpid $pid; then
53ae90e8
ER
720 # XXX: SIGKILL is sent already on 4th second!
721 # HARMFUL for example to mysqld (which is already workarounded)
228edf1d 722 kill -KILL $pid
723 usleep 100000
724 fi
7742e157 725 fi
228edf1d 726 checkpid $pid
bbb612de
AM
727 result=$?
728 if [ "$result" -eq 0 ]; then
228edf1d 729 fail
730 log_failed "$1 shutdown"
731 else
732 ok
733 log_success "$1 shutdown"
734 fi
735 result=$(( ! $result ))
736 else
737 # use specified level only
738 if checkpid $pid > /dev/null 2>&1; then
739 kill $killlevel $pid
740 result=$?
741 if [ "$result" -eq 0 ]; then
742 ok
743 log_success "$1 got $killlevel"
744 else
745 result=7
746 fail
747 log_failed "$1 didn't get $killlevel"
748 fi
e016cdae 749 else
228edf1d 750 result=7
751 died
752 log_failed "$1 shutdown"
e016cdae 753 fi
7742e157
AF
754 fi
755 else
228edf1d 756 died
757 log_failed "$1 shutdown"
758 result=7
7742e157 759 fi
5e6dfc29 760
683d384e 761 if [ -n "$waitname" -a -n "$waittime" ]; then
e6f93a80 762 # Save basename.
03e01a49 763 base=${waitname##*/}
e6f93a80
AM
764 # Find pid.
765 pid=$(pidofproc "$waitname" "$pidfile")
766 [ -z "$pid" ] && pid=$(pidofproc "$base" "$pidfile")
683d384e
AM
767 i=0
768 while [ "$i" -lt "$waittime" ]; do
1101d321 769 i=$(( i + 1 ))
683d384e
AM
770 checkpid $pid && sleep 1 || break
771 done
772 fi
7742e157 773
228edf1d 774 # Remove pid file if any.
e016cdae 775 if [ "$notset" = "1" ]; then
228edf1d 776 rm -f /var/run/${base}.pid
7742e157 777 fi
bbb612de
AM
778
779 return $result
7742e157
AF
780}
781
782# A function to find the pid of a program.
18bd13ac 783pidofproc() {
03e01a49 784 typeset pid pidfile base=${1##*/}
8de7f381
AM
785 pidfile="$base.pid"
786 [ -n "$2" ] && pidfile="$2"
7742e157 787
8a835e11 788 # Test syntax.
789 if [ $# = 0 ] ; then
790 msg_usage " pidofproc {program}"
791 return 2
792 fi
793
8de7f381 794 # First try pidfile or "/var/run/*.pid"
f955cf0f 795 if [[ "$pidfile" = /* ]]; then
1c26fe27
AM
796 pidfile="${pidfile}"
797 else
798 pidfile="/var/run/${pidfile}";
799 fi
800 if [ -f "${pidfile}" ] ; then
7eb94de6 801 typeset p pid
8a835e11 802 pid=
7eb94de6 803 for p in $(< "${pidfile}"); do
3030e60e 804 [ -z "$(echo "$p" | awk '{gsub(/[0-9]/,"");print;}')" ] && pid="$pid $p"
8a835e11 805 done
7742e157 806 fi
8a835e11 807
7742e157 808 # Next try "pidof"
1e5e8177
AM
809 [ -z "$pid" ] && pidof -o $$ -o $PPID -o %PPID -x "$1"
810 pid=$(filter_chroot "$pid")
811 echo $pid
7742e157 812}
12de71be 813
18bd13ac 814status() {
4e901aa0
ER
815 typeset pid subsys daemon cpuset_msg pidfile
816 if [ "$1" = "--pidfile" ]; then
817 pidfile=$2
818 shift 2
819 fi
820
8a835e11 821 subsys=$1
822 daemon=${2:-$subsys}
bbb612de 823
8a835e11 824 # Test syntax.
825 if [ $# = 0 ] ; then
4e901aa0 826 msg_usage " status [--pidfile PIDFILE] {subsys} [{daemon}]"
8a835e11 827 return 2
828 fi
bbb612de 829
4e901aa0
ER
830 # if pidfile specified, pid must be there
831 if [ "$pidfile" -a -f "$pidfile" ]; then
832 read pid < $pidfile
833 else
834 pid=$(pidof -o $$ -o $PPID -o %PPID -x $daemon)
835 fi
1e5e8177 836 pid=$(filter_chroot "$pid")
bbb612de 837
b90fbc1e 838 if [ "$pid" ]; then
814e38ce 839 cpuset_msg="..."
b90fbc1e 840 if [ -n "$SERVICE_CPUSET" ] && is_yes "$CPUSETS" ]; then
6c99c680 841 if $(grep -q "$pid" "/dev/cpuset/${SERVICE_CPUSET}/tasks"); then
814e38ce
JR
842 cpuset_msg=$(nls " in cpuset %s..." "$SERVICE_CPUSET")
843 else
844 cpuset_msg=$(nls " outside of configured cpuset %s..." "$SERVICE_CPUSET")
845 fi
846 fi
847 nls "%s (pid %s) is running%s" "$daemon" "$pid" "$cpuset_msg"
8a835e11 848 return 0
8a835e11 849 fi
850
851 # Next try "/var/run/*.pid" files
4e901aa0 852 local base=${daemon##*/}
8a835e11 853 if [ -f /var/run/${base}.pid ]; then
854 read pid < /var/run/${base}.pid
1e5e8177 855 pid=$(filter_chroot "$pid")
8a835e11 856 if [ "$pid" != "" ]; then
857 nls "%s dead but pid file exists" "$subsys"
858 return 1
859 fi
860 fi
861
862 # See if /var/lock/subsys/$subsys exists
863 if [ -f /var/lock/subsys/$subsys ]; then
864 nls "%s dead but subsys locked" "$subsys"
865 return 2
7742e157 866 fi
8a835e11 867 nls "%s is stopped" "$subsys"
868 return 3
7742e157 869}
0524c81f 870
6b4a354c
AM
871# Confirm whether we really want to run this service
872confirm() {
da1fc19d 873 typeset answer
d553f606 874 nls -n "Start service %s (Y)es/(N)o/(C)ontinue? [Y] " "$1"
6b4a354c
AM
875 read answer
876 case $answer in
739070c4 877 y|Y|t|T|j|J|"")
8a835e11 878 return 0
6b4a354c 879 ;;
739070c4 880 c|C|k|K|w|W)
8a835e11 881 return 2
6b4a354c 882 ;;
739070c4 883 n|N)
8a835e11 884 return 1
6b4a354c 885 ;;
739070c4 886 *)
8a835e11 887 confirm $1
888 return $?
6b4a354c
AM
889 ;;
890 esac
891}
892
d553f606 893# module is needed (ie. is requested, is available and isn't loaded already)
18bd13ac 894is_module() {
d553f606 895 # module name without .o at end
5778a670
ER
896 if ! lsmod | grep -q "$1"; then
897 if ls -R /lib/modules/$(uname -r)/ 2> /dev/null | grep -q "${1}.\(\|k\)o\(\|.gz\)"; then
d553f606
JR
898 # true
899 return 0
900 fi
901 fi
902 # false
903 return 1
0524c81f 904}
f7b2d235 905
18bd13ac 906_modprobe() {
da1fc19d 907 typeset parsed single die args foo result
f7b2d235 908 parsed=no
d553f606 909 while is_no "$parsed" ; do
f7b2d235 910 case "$1" in
739070c4 911 "single")
8a835e11 912 single=yes
913 shift
914 ;;
739070c4 915 "die")
8a835e11 916 die=yes
917 shift
918 ;;
739070c4 919 -*)
8a835e11 920 args="$args $1"
921 shift
922 ;;
739070c4 923 *)
8a835e11 924 parsed=yes
925 ;;
f7b2d235
JR
926 esac
927 done
928 if is_yes "${single}" ; then
929 foo="$@"
930 show "Loading %s kernel module(s)" "$foo"
f7b2d235
JR
931 busy
932 fi
933 if [ -x /sbin/modprobe ] ; then
934 /sbin/modprobe -s $args "$@"
935 result=$?
936 else
937 deltext ; fail
938 result=1
939 fi
940 if is_yes "${single}" ; then
941 deltext
942 if [ $result == "0" ] ; then
d553f606 943 is_yes "$single" && ok
f7b2d235
JR
944 else
945 fail
946 if is_yes "$die" ; then
947 nls "Could not load %s kernel module(s)" "$@"
948 exit 1
949 fi
950 fi
951 fi
f7b2d235 952}
d553f606 953
bc94aa53
ER
954if is_no "$RC_LOGGING"; then
955 log_success() {
956 :
957 }
d553f606 958
18bd13ac 959 log_failed() {
bc94aa53
ER
960 :
961 }
962else
18bd13ac 963 log_success() {
bc94aa53
ER
964 initlog -n $0 -s "$1 $2" -e 1
965 }
966
18bd13ac 967 log_failed() {
bc94aa53
ER
968 initlog -n $0 -s "$1 $2" -e 2
969 }
970fi
d553f606 971
f0c296a0
JR
972# Check if any flavor of portmapper is running
973check_portmapper() {
1cb7535e
JR
974 typeset RPCINFO
975
cbb91a00
ER
976 if [ -x /usr/sbin/rpcinfo ]; then
977 if /usr/sbin/rpcinfo -p localhost >/dev/null 2>/dev/null; then
fd8737b5 978 return 0
f0c296a0
JR
979 else
980 return 1
981 fi
982 elif [ -x /sbin/pidof ]; then
f74fbf2c 983 [ -z "$(/sbin/pidof portmap)" -a \
739070c4 984 -z "$(/sbin/pidof rpcbind)" ] && return 1
f0c296a0
JR
985 fi
986 return 0
987}
988
0084dcf3 989rc_cache_init() {
6e311c54
ER
990 # If we have cachefile, use it.
991 # If we don't, create memory variables and try to save silently,
acf05b4f 992 local cachefile='/var/cache/rc-scripts/msg.cache'
0084dcf3 993
4132441e
ER
994 local term
995 if is_yes "$ISATTY"; then
996 term=$TERM
997 else
998 term=dumb
999 fi
1000
0084dcf3
ER
1001 # We create $check variable which is used to invalidate the cache.
1002 # The $check contains user locale and terminal.
66f7cfac 1003 local check="$term.$LC_MESSAGES.$INIT_COL"
0084dcf3 1004
f9df72e7 1005 if [ -f "$cachefile" -a "$cachefile" -nt /etc/sysconfig/system -a "$cachefile" -nt /etc/sysconfig/init-colors ]; then
0084dcf3
ER
1006 if . "$cachefile" 2>/dev/null; then
1007 if [ "$check" = "$_check" ]; then
1008 return
1009 fi
1010 fi
f9df72e7
ER
1011 fi
1012
1013 # primitive caching
1014 _busy=$(progress "BUSY" "$CBUSY")
1015 _ok=$(progress "DONE")
1016 _started=$(progress "WORK")
1017 _fail=$(progress "FAIL" "$CFAIL")
1018 _died=$(progress "DIED" "$CFAIL")
cc54351b
ER
1019
1020 # we don't use heredoc, as ksh attempts to create tempfile then
3ba0bc12 1021 (> "$cachefile" ) 2>/dev/null || return
cc54351b
ER
1022 echo "_busy='$_busy';" >> "$cachefile"
1023 echo "_ok='$_ok';" >> "$cachefile"
1024 echo "_started='$_started';" >> "$cachefile"
1025 echo "_fail='$_fail';" >> "$cachefile"
1026 echo "_died='$_died';" >> "$cachefile"
1027 echo "_check='$check';" >> "$cachefile"
f9df72e7
ER
1028}
1029
0084dcf3 1030rc_gettext_init() {
9a0a016d
ER
1031 if [ -z "$GETTEXT" ]; then
1032 if [ -x /bin/gettext -o -x /usr/bin/gettext ]; then
1033 GETTEXT=yes
1034 else
1035 GETTEXT=no
1036 fi
1037 fi
1038
1039 if [ -z "$TPUT" ]; then
1040 if [ -d /usr/share/terminfo ] && [ -x /usr/bin/tput -o -x /bin/tput ] ; then
1041 TPUT=yes
1042 # check if we are on proper terminal
1043 tput longname >/dev/null 2>&1 || TPUT=no
1044 else
1045 TPUT=no
1046 fi
1047 fi
1048}
1049
0084dcf3
ER
1050rc_gettext_init
1051rc_cache_init
f9df72e7 1052
bbb612de
AM
1053#/*
1054# * Local variables:
1055# * mode: sh
1056# * indent-tabs-mode: notnil
1057# * End:
1058# *
bbb612de 1059# */
This page took 0.258574 seconds and 4 git commands to generate.